#include <project.h>

int count = 0;
int count1 = 0;
int count2 = 0;
int count3 = 0;
int N = 1000;
int delay = 1;
int ON = 1u;
int OFF = 0u;


/***************************************************************
 * Function to update the LED state in the GATT database
 **************************************************************/
void updateRed()
{
    CYBLE_GATTS_HANDLE_VALUE_NTF_T 	tempHandle;
    
    uint8 red_State = ~red_Read();
    
    if(CyBle_GetState() != CYBLE_STATE_CONNECTED)
        return;
    
    tempHandle.attrHandle = CYBLE_LEDCAPSENSE_LEDBLINK_CHAR_HANDLE;
  	tempHandle.value.val = (uint8 *) &red_State;
    tempHandle.value.len = 1;
    CyBle_GattsWriteAttributeValue(&tempHandle,0,&cyBle_connHandle,CYBLE_GATT_DB_LOCALLY_INITIATED);  
}
void updateGreen()
{
    CYBLE_GATTS_HANDLE_VALUE_NTF_T 	tempHandle;
    
    uint8 green_State = ~green_Read();
    
    if(CyBle_GetState() != CYBLE_STATE_CONNECTED)
        return;
    
    tempHandle.attrHandle = CYBLE_LEDCAPSENSE_LEDBLINK_CHAR_HANDLE;
  	tempHandle.value.val = (uint8 *) &green_State;
    tempHandle.value.len = 1;
    CyBle_GattsWriteAttributeValue(&tempHandle,0,&cyBle_connHandle,CYBLE_GATT_DB_LOCALLY_INITIATED);  
}

void PumpSwitchCallback() 
{
    mux_setting_Write(1);//set mux to output to 1, red LED
}

void BleCallBack(uint32 event, void* eventParam)
{
    CYBLE_GATTS_WRITE_REQ_PARAM_T *wrReqParam;

    switch(event)
    {
        /* if there is a disconnect or the stack just turned on from a reset then start the advertising and turn on the LED blinking */
        case CYBLE_EVT_STACK_ON:
        case CYBLE_EVT_GAP_DEVICE_DISCONNECTED:
            CyBle_GappStartAdvertisement(CYBLE_ADVERTISING_FAST);
            mux_setting_Write(2);//set mux to output to 2, blue LED
            start_timer_Write(0);
        break;
        
        /* when a connection is made, update the LED and Capsense states in the GATT database and stop blinking the LED */    
        case CYBLE_EVT_GATT_CONNECT_IND:
            updateRed();
            updateGreen();
            mux_setting_Write(0);//set mux to output to 0, nothing
		break;

        /* handle a write request */
        case CYBLE_EVT_GATTS_WRITE_REQ:
            wrReqParam = (CYBLE_GATTS_WRITE_REQ_PARAM_T *) eventParam;
            if(wrReqParam->handleValPair.attrHandle == CYBLE_LEDCAPSENSE_LEDBLINK_CHAR_HANDLE)
                {
                    /* only update the value and write the response if the requested write is allowed */
                    if(CYBLE_GATT_ERR_NONE == CyBle_GattsWriteAttributeValue(&wrReqParam->handleValPair, 0, &cyBle_connHandle, CYBLE_GATT_DB_PEER_INITIATED))
                    {
                        isr_switch_pumps_StartEx(PumpSwitchCallback);//interrupt to switch mux output to 1 when time is up to switch from green to red LED
                        switch_pump_Start();//make sure the timer is running/enabled
                        start_timer_Write(1);//start the timer
                        mux_setting_Write(3);//set mux to output to 3, green LED
                        CyBle_GattsWriteRsp(cyBle_connHandle);   
                    }
                }
			break;  
        
        default:
            break;
    }
} 

/***************************************************************
 * Main
 **************************************************************/
int main()
{
    CyGlobalIntEnable; 
    
   pwm_signal_Start();//Start the pwm blinking signal
    
    /* Start BLE stack and register the callback fuction */
    CyBle_Start(BleCallBack);

    for(;;)
    {        
   
        CyBle_ProcessEvents();
     //   CyBle_EnterLPM(CYBLE_BLESS_DEEPSLEEP);    
    }
}
